#include "HAL_conf.h"
#include "HAL_device.h"
#include "stdio.h"

u32 TEXT_TO_SEND[] = {'1','2','3','4','5','6','7','8','9'};
#define TEXT_LENTH 9
u8 SendBuff[(TEXT_LENTH+2)*100];
/*DMAÿݴ͵ĳ*/
u16 DMA1_MEM_LEN;			                                                     
char printBuf[100];

void uart_initwBaudRate(u32 bound);
void MYDMA_Config(DMA_Channel_TypeDef* DMA_CHx,u32 cpar,u32 cmar,u16 cndtr);
void MYDMA_Enable(DMA_Channel_TypeDef*DMA_CHx);
void UartSendGroup(u8* buf,u16 len);

/********************************************************************************************************
**Ϣ int main (void)                          
** 󣬴ڴӡ(MM32link-option )
** 
** 
********************************************************************************************************/
int main(void)
{ 
    u16 i;
    u8 t=0; 
    
    /*ڳʼΪ9600*/
    uart_initwBaudRate(9600); 
    /*DMA1ͨ4,Ϊ1,洢ΪSendBuff,(TEXT_LENTH+2)*10*/    
    MYDMA_Config(DMA1_Channel4,(u32)&UART1->TDR,(u32)SendBuff,(TEXT_LENTH+2)*10);	
	UartSendGroup((u8*)printBuf, sprintf(printBuf,"\r\nDMA DATA:\r\n"));
    /*ASCIIַ*/
    for(i=0;i<(TEXT_LENTH+2)*100;i++)					                        
    { 
        /*뻻з*/
        if(t>=TEXT_LENTH)								                        
        { 
            SendBuff[i++]=0x0d; 
            SendBuff[i]=0x0a; 
            t=0;
        }
        /*TEXT_TO_SEND*/
        else SendBuff[i]=TEXT_TO_SEND[t++];			                            
    } 
    
    /*ʹuart1 DMA*/
    UART_DMACmd(UART1,UART_DMAReq_EN,ENABLE);
    /*ʼһDMA䣡*/    
    MYDMA_Enable(DMA1_Channel4);					        	                
    
    /*ȴDMAɣʱһЩ£*/
    /*ʵӦУڼ䣬ִ*/
    while(1) 
    { 
        /*ȴͨ4*/
        if(DMA_GetFlagStatus(DMA1_FLAG_TC4)!=RESET)		                        
        { 
            /*ͨ4ɱ־*/
            DMA_ClearFlag(DMA1_FLAG_TC4);				                        
            break; 
        } 
    } 

    UartSendGroup((u8*)printBuf, sprintf(printBuf,"\r\nUART DMA TEST OK!\r\n"));	
    
    while(1);
}

/********************************************************************************************************
**Ϣ void uart_initwBaudRate(u32 bound)     
** UARTʼ
** bound
** 
**    ע 
********************************************************************************************************/
void uart_initwBaudRate(u32 bound)
{
    /*GPIO˿*/
    GPIO_InitTypeDef GPIO_InitStructure;
    UART_InitTypeDef UART_InitStructure;
    
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);
    
    /*UART1_TX   GPIOA.9*/
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;                                   
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    /**/    
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;		                     
    GPIO_Init(GPIOA, &GPIO_InitStructure);				                        
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource9, GPIO_AF_7);
    
    /*UART1_RX  GPIOA.10ʼ*/
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    /**/
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;	                 
    GPIO_Init(GPIOA, &GPIO_InitStructure);				                     
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource10, GPIO_AF_7);
    
    /*UART ʼ*/
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_UART1, ENABLE);	                   

    /*ڲ*/
    UART_InitStructure.UART_BaudRate = bound;
    /*ֳΪ8λݸʽ*/    
    UART_InitStructure.UART_WordLength = UART_WordLength_8b;
    /*һֹͣλ*/    
    UART_InitStructure.UART_StopBits = UART_StopBits_1;
    /*żУλ*/    
    UART_InitStructure.UART_Parity = UART_Parity_No;
    /*Ӳ*/    
    UART_InitStructure.UART_HardwareFlowControl = UART_HardwareFlowControl_None;
    /*շģʽ*/
    UART_InitStructure.UART_Mode = UART_Mode_Rx | UART_Mode_Tx;	                
    /*ʼ1*/
    UART_Init(UART1, &UART_InitStructure); 	
    /*ڽж*/    
    UART_ITConfig(UART1, UART_IT_RXIEN, ENABLE);
    /*ʹܴ1*/    
    UART_Cmd(UART1, ENABLE);                    			                    
}

/********************************************************************************************************
**Ϣ MYDMA_Config(DMA_Channel_TypeDef* DMA_CHx,u32 cpar,u32 cmar,u16 cndtr)                      
** ޸ĸ޸õDMA
** 
** 
********************************************************************************************************/
void MYDMA_Config(DMA_Channel_TypeDef* DMA_CHx,u32 cpar,u32 cmar,u16 cndtr)
{
    DMA_InitTypeDef DMA_InitStructure;
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_DMA1, ENABLE);			            
    
    /*DMAͨ1ĴΪȱʡֵ*/
    DMA_DeInit(DMA_CHx); 							                            
    DMA1_MEM_LEN=cndtr;
    /*DMAADCַ*/
    DMA_InitStructure.DMA_PeripheralBaseAddr = cpar;  	
    /*DMAڴַ*/    
    DMA_InitStructure.DMA_MemoryBaseAddr = cmar;  	
    /*ݴ䷽򣬴ڴȡ͵*/    
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralDST;  	
    /*DMAͨDMAĴС*/    
    DMA_InitStructure.DMA_BufferSize = cndtr;  		
    /*ַĴ*/    
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable; 
    /*ڴַĴ*/    
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
    /*ݿΪ8λ*/    
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;  
    /*ݿΪ8λ*/	
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte; 
    /*ģʽ*/    
    DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;  		
    /*DMAͨ xӵȼ*/    
    DMA_InitStructure.DMA_Priority = DMA_Priority_Medium; 	
    /*DMAͨxûΪڴ浽ڴ洫*/    
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable; 	
    /*DMA_InitStructָĲʼDMAͨUART1_Tx_DMA_ChannelʶļĴ*/    
    DMA_Init(DMA_CHx, &DMA_InitStructure);  					                
    
}

/********************************************************************************************************
**Ϣ MYDMA_Enable(DMA_Channel_TypeDef*DMA_CHx)                   
** ʼһDMA
** 
** 
********************************************************************************************************/
void MYDMA_Enable(DMA_Channel_TypeDef*DMA_CHx)
{ 
    /*رUART1 TX DMA1 ָʾͨ*/
    DMA_Cmd(DMA_CHx, DISABLE );  	
    /*ʹUART1 TX DMA1 ָʾͨ*/     
    DMA_Cmd(DMA_CHx, ENABLE);  		                                            
}

/********************************************************************************************************
**Ϣ void UartSendByte(u8 dat)      
** UART
** dat
** 
**    ע 
********************************************************************************************************/
void UartSendByte(u8 dat)
{
    UART_SendData( UART1, dat);
    while(!UART_GetFlagStatus(UART1,UART_FLAG_TXEPT));
}


/********************************************************************************************************
**Ϣ void UartSendGroup(u8* buf,u16 len)     
** UART
** buf,len
** 
**    ע 
********************************************************************************************************/
void UartSendGroup(u8* buf,u16 len)
{
    while(len--)
        UartSendByte(*buf++);
}
