#include "HAL_conf.h"
#include "HAL_device.h"
#include "stdio.h"

void HSI_Pll_test(unsigned int pllmul);

/********************************************************************************************************
**Ϣ int main (void)                          
** ARMLED
** 
** 
********************************************************************************************************/
int main(void)
{
    /*ѡڲʱԴΪƵʱӵĻ*/
    HSI_Pll_test(RCC_PLLMul_6);	                                                
    
    while(1)              		
    {
        
    }
}


/********************************************************************************************************
**Ϣ SystemClk_HSIInit (void)                        
** ϵͳʱӳʼʼ֮ǰȸλʱ
** 
** 
********************************************************************************************************/
void SystemClk_HSIInit()
{
    
    GPIO_InitTypeDef  GPIO_InitStructure;
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE); 
    /*mco  pa8*/
    GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_8;   			                    
    GPIO_InitStructure.GPIO_Speed =  GPIO_Speed_10MHz;  
    /**/
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 		                    
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource8, GPIO_AF_0);
    /*CRĴBIT0λHSIONλ1ڲʱHSIΪϵͳʱ*/
    RCC_HSICmd(ENABLE);
    
    /*ͨPA8 pin ۲Ƶ*/
    RCC_MCOConfig(RCC_MCO_SYSCLK); 
    /*ѡڲʱΪϵͳʱ*/    
    RCC_SYSCLKConfig(RCC_SYSCLKSource_HSI);					                    
}

/********************************************************************************************************
**Ϣ SystemClkPll(unsigned int pllmul)                
** ƵƵΪϵͳʱ
** ƵѡRCC_PLLMul_2  RCC_PLLMul_16 
** 
********************************************************************************************************/
void SystemClkPll(unsigned int pllmul)
{
    /*ʹPLL*/
    RCC_PLLCmd(ENABLE); 				                                        
    
    while(1){
        /*ѯPLL ready*/
        if(RCC->CR&0x02000000) 				                                    
        {
            break;
        }
    }
    
    /*ʱӵȴ״̬*/
    FLASH_SetLatency(FLASH_Latency_2);			                                 
   
    /*ͨPA8 pin ۲Ƶ*/    
    RCC_MCOConfig(RCC_MCO_PLLCLK_Div2);  	
    /*ѡPLLʱΪϵͳʱ*/    
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);	                            	
}

/********************************************************************************************************
**Ϣ HSE_Pll_test(unsigned int pllmul)                      
** ⲿΪʱԴ
** ƵѡRCC_PLLMul_2  RCC_PLLMul_16 
** 
********************************************************************************************************/
void HSI_Pll_test(unsigned int pllmul)
{
    
    SystemClk_HSIInit();
    /*ѡڲʱԴΪƵʱӵĻ*/
    RCC_PLLConfig(RCC_PLLSource_HSI_Div4, pllmul);                              
    SystemClkPll(pllmul);
}

/********************************************************************************************************
**Ϣ LSI_clk()                      
** ڲƵʱӲͨʾ۲PA8 pin 40KHz
** 
** 
********************************************************************************************************/
void LSI_clk()
{
    
    GPIO_InitTypeDef  GPIO_InitStructure;
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE); 
    /*mco  pa8*/
    GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_8;  				                
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    /**/
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 			                
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource8, GPIO_AF_0);
    //open lsi on
    RCC_LSICmd(ENABLE);
    
    while(1)
    {
        /*ѯڲƵʱready*/
        if(RCC->CSR&0x00000002) 						                        
        {                                                                       
            break;                                                              
        }                                                                       
    }                                                                           
    /*ͨPA8 pin ۲Ƶ*/                                                                      
    RCC_MCOConfig(RCC_MCO_LSI);  						                        
}                                                                               
